
love.graphics.setDefaultFilter("nearest", "nearest")

-- Create a new Animation Object --
-- Note: this method isn't that efficent! --
function newAnimation(imagePath, fw, fh, delay)
  local animation = {}
  animation.image = love.graphics.newImage(imagePath)
  animation.fw = fw
  animation.fh = fh
  animation.delay = delay or .1
  animation.timer = 0
  animation.quads = {}
  animation.state = "paused"
  animation.currentFrame = 1
  
  local iw, ih = animation.image:getDimensions()
  for i = 1, iw/fw do
    animation.quads[i] = love.graphics.newQuad(animation.fw * i - animation.fw, 0, animation.fw, animation.fh, animation.image:getDimensions())
  end
  
  animation.play = function(self)
    self.currentFrame = 1
    self.state = "playing"
  end
  
  animation.pause = function(self)
    self.state = "paused"
  end
  
  animation.resume = function(self)
    self.state = "playing"
  end
  
  animation.update = function(self, dt)
    self.timer = self.timer + dt
    if self.timer > self.delay and self.state == "playing" then
      if self.currentFrame < #self.quads then self.currentFrame = self.currentFrame+1
    else self.currentFrame = 1 end
    self.timer = 0
    end
  end
  
  animation.draw = function(self, x, y, sx, sy, ox, oy, kx, ky)
    love.graphics.draw(self.image, self.quads[self.currentFrame], x or 0, y or 0, sx or 1, sy or 1, ox or 0, oy or 0, kx or 0, ky or 0)
  end
  
  return animation
end


local men1 = newAnimation("spritesheet.png", 10, 12, .1)
men1:play()

function love.update(dt)
  men1:update(dt)
end

function love.draw()
  men1:draw(100, 100, 0, 4, 4)
end

function love.keypressed(key)
  if key == "escape" then love.event.quit() end
end
